// ---- variables section

extern bool      trailStop = true;
extern int       ATRTimeFrame=0;
extern int       ATRPeriod=14;
extern int       ATRShift = 1;
extern int       StartMultiple=2;
extern int       TrailMultiple=4;

// ---- ChandelierStop function

void ChandelierStop( int startTrail, int trailBy, int magic)
{
  if (startTrail >=5)
   {
  for (int i = 0; i < OrdersTotal(); i++) 
      {
     OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
     if (OrderSymbol()==Symbol() && OrderMagicNumber() == magic)
         {
            if (OrderType() == OP_BUY) 
               {
                  if (Bid - OrderOpenPrice() > startTrail * Point) 
                     {
                        if (OrderStopLoss() < Bid - trailBy * Point)
                           {
                              OrderModify(OrderTicket(), OrderOpenPrice(), Bid - trailBy * Point, OrderTakeProfit(),0, Red);
                           }
                     }
                }
            if (OrderType() == OP_SELL) 
               {
                  if (OrderOpenPrice() - Ask > startTrail * Point)
                     {
                        if ((OrderStopLoss() > Ask + trailBy * Point) || (OrderStopLoss() == 0))
                           {
                              OrderModify(OrderTicket(), OrderOpenPrice(),Ask + trailBy * Point, OrderTakeProfit(),0, Red);
                     }   
               }
            }
         }
      }
   }
}

// ----
int trailStart=(iATR(NULL,ATRTimeFrame,ATRPeriod,ATRShift)*StartMultiple)/Point;
int trailBy=(iATR(NULL,ATRTimeFrame,ATRPeriod,ATRShift)*TrailMultiple)/Point;
if (trailStop == true) ChandelierStop(trailStart, trailBy, magicNumber); 

